# Method: customers.describeValidFrequencyLimitingEventMatchers

- [HTTP request](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.request_body)
- [Response body](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.response_body)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.DescribeValidFrequencyLimitingEventMatchersResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#body.aspect)
- [EventMatcherInfo](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherInfo)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherInfo.SCHEMA_REPRESENTATION)
- [EventMatcherMetadata](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherMetadata)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherMetadata.SCHEMA_REPRESENTATION)

> [!WARNING]
> Frequency capping audiences are no longer supported in Ads Data Hub due to the upstream [deprecation of frequency-based audiences in Display \& Video 360](https://support.google.com/displayvideo/answer/13439592).

Lists valid event matchers along with their metadata for frequency capping audience lists. Each event matcher has metadata that includes, for example, an owning AdsDataLink.Entity and a name for the corresponding campaign or line item.

### HTTP request

`GET https://adsdatahub.googleapis.com/v1/{customer=customers/*}:describeValidFrequencyLimitingEventMatchers`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `customer` | `string` Customer resource name, e.g. 'customers/123'. |

### Query parameters

| Parameters ||
|---|---|
| `adsDataCustomerId` | `string (https://developers.google.com/discovery/v1/type-format format)` Ads Data Owning customer's ID, e.g. 456. |
| `pageSize` | `integer` Maximum number of items to return. If 0, the server will determine the number of linked customers to return. |
| `pageToken` | `string` Page token, returned by a previous call, used to request the next page of results, if any. |
| `filter` | `string` Restrict which event matchers are returned. Accepts filters on all the sub-fields of eventMatcher, eventMatcherMetadata.entity, and eventMatcherMetadata.parent_event_matcher. Example filters: eventMatcher.value = 1234 eventMatcher.match_type = DV360_LINE_ITEM_ID OR eventMatcher.match_type = DV360_INSERTION_ORDER_ID eventMatcherMetadata.display_name = "Campaign 456" eventMatcherMetadata.entity.entity_id = 5678 eventMatcherMetadata.entity.display_name = "Customer 123" eventMatcherMetadata.entity.type = GMP_DV360_ADVERTISER eventMatcherMetadata.parent_event_matcher.value = 6789 eventMatcherMetadata.parent_event_matcher.match_type = DV360_INSERTION_ORDER_ID |

### Request body

The request body must be empty.

### Response body

Response to a DescribeValidFrequencyLimitingEventMatchersRequest request.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "eventMatcherInfos": [ { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherInfo`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `eventMatcherInfos[]` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherInfo`)`` List of units, each containing an event matcher along with its metadata |
| `nextPageToken` | `string` A token that can be used to request the next results page. This field is empty if there are no additional results. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/adsdatahub`

## EventMatcherInfo

Event matcher along with its metadata.

| JSON representation |
|---|
| ``` { "eventMatcher": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#EventMatcher`) }, "eventMatcherMetadata": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherMetadata`) } } ``` |

| Fields ||
|---|---|
| `eventMatcher` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#EventMatcher`)`` Event matcher containing the constraint type and valid constraint ID. |
| `eventMatcherMetadata` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/describeValidFrequencyLimitingEventMatchers#EventMatcherMetadata`)`` Metadata for the event matcher. |

## EventMatcherMetadata

Metadata for the event matcher.

| JSON representation |
|---|
| ``` { "entity": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.adsDataLinks#Entity`) }, "displayName": string, "parentEventMatcher": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#EventMatcher`) } } ``` |

| Fields ||
|---|---|
| `entity` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.adsDataLinks#Entity`)`` Linked entity from AdsDataLink. |
| `displayName` | `string` Name in the underlying data store for the constraint. This could be a campaign name, a line item name etc. |
| `parentEventMatcher` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#EventMatcher`)`` Related parent EventMatcher, if any. If eventMatcher is a DV360 line item, this field will refer to the EventMatcher for the corresponding DV360 insertion order that the line item is part of. |